"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AlleleFrequency(ProtocolElement):
    """
    The population allele frequency of a given variant in a given study
    and optionally population
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alternateFrequency",
        "population",
        "study",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "org.gel.models.report.avro.AlleleFrequency": reports_6_5_0.AlleleFrequency,
        }

    __slots__ = [
        "alternateFrequency",
        "population",
        "study",
    ]

    def __init__(
        self,
        alternateFrequency,
        population,
        study,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_5_0.AlleleFrequency model.

        :param alternateFrequency:
            The frequency of the alternate allele
        :type alternateFrequency: float
        :param population:
            The specific population where this allele frequency belongs
        :type population: str
        :param study:
            The study from where this data comes from
        :type study: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.5.0"
